# Introduction

This repo provides instructions on the installation and use of code on the Stretch RE1 robot. The goal is to provide a user familiar with ROS with the tools to operate a Stretch robot in simulation and the actual robot.

## Stretch ROS Tutorials
1. [Getting Started](getting_started.md)
2. [Gazebo Basics](gazebo_basics.md)
3. [Teleoperating Stretch](teleoperating_stretch.md)
4. [Internal State of Stretch](internal_state_of_stretch.md)
5. [RViz Basics](rviz_basics.md)
6. [Navigation Stack](navigation_stack.md)
7. [MoveIt! Basics](moveit_basics.md)
8. [Perception]
9. [Microphone Array]
10. [FUNMAP]


## Other ROS Examples

1. [Teleoperate Stretch with a Node](example_1.md) - Use a python script that sends velocity commands.  
2. Mobile Base Collision Avoidance - Stop stretch from running into a wall.
3. [Give Stretch a Balloon](example_3.md) - Create a "balloon" marker that goes where ever it goes.
